diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 57433468e..240f39051 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -51,6 +51,8 @@ import net.minecraft.core.world.lighting.LightingEngine;
 import net.minecraft.core.world.lighting.LightingEngineLegacy;
 import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
@@ -67,7 +69,7 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
-public class World implements WorldSource {
+public class World implements MutableWorldSource {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static boolean AUTOSAVE = true;
 
@@ -115,7 +117,7 @@ public class World implements WorldSource {
     protected boolean enoughPlayersSleeping;
     public SavedDataStorage savedDataStorage;
     protected final LightingEngine lightingEngine = new LightingEngineLegacy(this);
-    private boolean updatingBlockEntities;
+    private boolean updatingTileEntities;
 
     private int caveSoundCounter = this.rand.nextInt(12000);
     public boolean isClientSide = false;
@@ -304,8 +306,8 @@ public class World implements WorldSource {
         return levelData.getSpawnerConfig();
     }
 
-    public int getHeightBlocks()
-    {
+    @Override
+    public int getHeightBlocks() {
         return Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     }
 
@@ -426,56 +428,45 @@ public class World implements WorldSource {
     }
 
     @Override
-    public int getBlockId(int x, int y, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    public int getBlockId(final @NotNull TilePos tilePos) {
+        if (!tilePos.inBounds(this)) {
             return 0;
-        }
-        if(y < 0)
-        {
-            return 0;
-        }
-        if(y >= getHeightBlocks())
-        {
-            return 0;
-        } else
-        {
-            return getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z)).getBlockID(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+        } else {
+            return this.getChunkFromChunkCoords(
+                Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X),
+                Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z)
+            ).getBlockID(
+                tilePos.x & (Chunk.CHUNK_SIZE_X - 1),
+                tilePos.y,
+                tilePos.z & (Chunk.CHUNK_SIZE_Z - 1)
+            );
         }
     }
 
     @Override
-    public @Nullable Block<?> getBlock(int x, int y, int z) {
-        return Blocks.getBlock(getBlockId(x, y, z));
+    public @Nullable Block<?> getBlock(final @NotNull TilePos tilePos) {
+        return Blocks.getBlock(this.getBlockId(tilePos));
     }
 
     @Override
-    public double getBlockTemperature(int x, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    public double getBlockTemperature(final @NotNull TilePos tilePos) {
+        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
             return 0;
-        }
-        else
-        {
-            int chunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-            int chunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
+        } else {
+            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
             double temperature = Double.NEGATIVE_INFINITY;
-            Chunk chunk = null;
+            @Nullable Chunk chunk = null;
 
-            if (isChunkLoaded(chunkX, chunkZ))
-            {
-                chunk = getChunkFromChunkCoords(chunkX, chunkZ);
-                temperature = chunk.getBlockTemperature(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
+            if (this.isChunkLoaded(chunkX, chunkZ)) {
+                chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
+                temperature = chunk.getBlockTemperature(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
-            if (temperature == Double.NEGATIVE_INFINITY)
-            {
-                temperature = getBiomeProvider().getTemperature(x, z);
-                if (chunk != null)
-                {
-                    chunk.setBlockTemperature(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1), temperature);
+            if (temperature == Double.NEGATIVE_INFINITY) {
+                temperature = getBiomeProvider().getTemperature(tilePos.x, tilePos.z);
+                if (chunk != null) {
+                    chunk.setBlockTemperature(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), temperature);
                 }
             }
 
@@ -483,31 +474,24 @@ public class World implements WorldSource {
         }
     }
     @Override
-    public double getBlockHumidity(int x, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    public double getBlockHumidity(final @NotNull TilePos tilePos) {
+        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
             return 0;
-        }
-        else
-        {
-            int chunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-            int chunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
+        } else {
+            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
             double humidity = Double.NEGATIVE_INFINITY;
-            Chunk chunk = null;
+            @Nullable Chunk chunk = null;
 
-            if (isChunkLoaded(chunkX, chunkZ))
-            {
-                chunk = getChunkFromChunkCoords(chunkX, chunkZ);
-                humidity = chunk.getBlockHumidity(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
+            if (this.isChunkLoaded(chunkX, chunkZ)) {
+                chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
+                humidity = chunk.getBlockHumidity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
-            if (humidity == Double.NEGATIVE_INFINITY)
-            {
-                humidity = getBiomeProvider().getHumidity(x, z);
-                if (chunk != null)
-                {
-                    chunk.setBlockHumidity(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1), humidity);
+            if (humidity == Double.NEGATIVE_INFINITY) {
+                humidity = this.getBiomeProvider().getHumidity(tilePos.x, tilePos.z);
+                if (chunk != null) {
+                    chunk.setBlockHumidity(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), humidity);
                 }
             }
 
@@ -516,35 +500,29 @@ public class World implements WorldSource {
     }
 
     @Override
-    public SeasonManager getSeasonManager() {
-        return seasonManager;
+    public @NotNull SeasonManager getSeasonManager() {
+        return this.seasonManager;
     }
 
-    public double getBlockVariety(int x, int z)
-    {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+    @Override
+    public double getBlockVariety(final @NotNull TilePos tilePos) {
+        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
             return 0;
-        }
-        else
-        {
-            int chunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-            int chunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
+        } else {
+            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
             double variety = Double.NEGATIVE_INFINITY;
-            Chunk chunk = null;
+            @Nullable Chunk chunk = null;
 
-            if (isChunkLoaded(chunkX, chunkZ))
-            {
-                chunk = getChunkFromChunkCoords(chunkX, chunkZ);
-                variety = chunk.getBlockVariety(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
+            if (this.isChunkLoaded(chunkX, chunkZ)) {
+                chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
+                variety = chunk.getBlockVariety(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
-            if (variety == Double.NEGATIVE_INFINITY)
-            {
-                variety = getBiomeProvider().getVariety(x, z);
-                if (chunk != null)
-                {
-                    chunk.setBlockVariety(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1), variety);
+            if (variety == Double.NEGATIVE_INFINITY) {
+                variety = this.getBiomeProvider().getVariety(tilePos.x, tilePos.z);
+                if (chunk != null) {
+                    chunk.setBlockVariety(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), variety);
                 }
             }
 
@@ -553,31 +531,25 @@ public class World implements WorldSource {
     }
 
     @Override
-    public @NotNull Biome getBlockBiome(int x, int y, int z)
+    public @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos)
     {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
+        if (!tilePos.inBounds(this)) {
             return Biomes.OVERWORLD_PLAINS;
-        }
-        else
-        {
-            int chunkX = Math.floorDiv(x, Chunk.CHUNK_SIZE_X);
-            int chunkZ = Math.floorDiv(z, Chunk.CHUNK_SIZE_Z);
-            Biome biome = null;
-            Chunk chunk = null;
+        } else {
+            final int chunkX = Math.floorDiv(tilePos.x, Chunk.CHUNK_SIZE_X);
+            final int chunkZ = Math.floorDiv(tilePos.z, Chunk.CHUNK_SIZE_Z);
+            @Nullable Biome biome = null;
+            @Nullable Chunk chunk = null;
 
-            if (isChunkLoaded(chunkX, chunkZ))
-            {
-                chunk = getChunkFromChunkCoords(chunkX, chunkZ);
-                biome = chunk.getBlockBiome(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1));
+            if (this.isChunkLoaded(chunkX, chunkZ)) {
+                chunk = this.getChunkFromChunkCoords(chunkX, chunkZ);
+                biome = chunk.getBlockBiome(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1));
             }
 
-            if (biome == null)
-            {
-                biome = getBiomeProvider().getBiome(x, y, z);
-                if (chunk != null)
-                {
-                    chunk.setBlockBiome(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), biome);
+            if (biome == null) {
+                biome = this.getBiomeProvider().getBiome(tilePos.x, tilePos.y, tilePos.z);
+                if (chunk != null) {
+                    chunk.setBlockBiome(tilePos.x & (Chunk.CHUNK_SIZE_X - 1), tilePos.y, tilePos.z & (Chunk.CHUNK_SIZE_Z - 1), biome);
                 }
             }
 
@@ -587,63 +559,67 @@ public class World implements WorldSource {
         }
     }
 
-    public boolean getBlockLitInteriorSurface(int x, int y, int z)
+    public boolean getBlockLitInteriorSurface(final @NotNull TilePos tilePos)
     {
-        if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
-        {
-            return true;
-        }
-        if(y < 0)
-        {
-            return true;
-        }
-        if(y >= getHeightBlocks())
-        {
+        if (!tilePos.inBounds(this)) {
             return true;
-        } else
-        {
-            return Block.getIsLitInteriorSurface(this, x, y, z);
+        } else {
+            return Block.getIsLitInteriorSurface(this, tilePos.x, tilePos.y, tilePos.z);
         }
     }
 
-    public boolean isAirBlock(int x, int y, int z)
-    {
-        return getBlockId(x, y, z) == 0;
+    @Deprecated
+    public final boolean getBlockLitInteriorSurface(final int x, final int y, final int z) {
+        return this.getBlockLitInteriorSurface(new TilePos(x, y, z));
     }
 
-    public boolean isBlockLoaded(int x, int y, int z)
-    {
-        if(y < 0 || y >= getHeightBlocks())
-        {
-            return false;
-        }
-        else
-        {
-            return isChunkLoaded(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
-        }
+    public boolean isAirBlock(final @NotNull TilePos tilePos) {
+        return this.getBlockId(tilePos) == 0;
     }
 
-    public boolean areBlocksLoaded(int x, int y, int z, int range)
-    {
-        return areBlocksLoaded(x - range, y - range, z - range, x + range, y + range, z + range);
+    @Deprecated
+    public final boolean isAirBlock(final int x, final int y, final int z) {
+        return this.isAirBlock(new TilePos(x, y, z));
     }
 
-    public boolean areBlocksLoaded(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
-    {
-        if(maxY < 0 || minY >= getHeightBlocks())
-        {
+    public boolean isBlockLoaded(final @NotNull TilePos tilePos) {
+        if (!tilePos.inBounds(this)) {
             return false;
+        } else {
+            return this.isChunkLoaded(tilePos.toChunkPos());
         }
+    }
+
+    @Deprecated
+    public final boolean isBlockLoaded(final int x, final int y, final int z) {
+        return this.isBlockLoaded(new TilePos(x, y, z));
+    }
+
+    public boolean areBlocksLoaded(final @NotNull TilePos tilePos, final int range) {
+        return this.areBlocksLoaded(tilePos.sub(range, range, range), tilePos.add(range, range, range));
+    }
+
+    @Deprecated
+    public final boolean areBlocksLoaded(final int x, final int y, final int z, final int range) {
+        return this.areBlocksLoaded(new TilePos(x, y, z), range);
+    }
+
+    public boolean areBlocksLoaded(final @NotNull TilePos min, final @NotNull TilePos max) {
+        int minX = Math.min(min.x, max.x);
+        int minZ = Math.min(min.z, max.z);
+        int maxX = Math.max(min.x, max.x);
+        int maxZ = Math.max(min.z, max.z);
+
         minX >>= 4;
         minZ >>= 4;
         maxX >>= 4;
         maxZ >>= 4;
-        for (int chunkX = minX; chunkX <= maxX; chunkX++)
-        {
-            for (int chunkZ = minZ; chunkZ <= maxZ; chunkZ++)
-            {
-                if (!isChunkLoaded(chunkX, chunkZ))
-                {
+
+        final @NotNull ChunkPos chunkPos = new ChunkPos(minX, minZ);
+
+        for (; chunkPos.x <= maxX; chunkPos.x++) {
+            for (; chunkPos.z <= maxZ; chunkPos.z++) {
+                if (!this.isChunkLoaded(chunkPos)) {
                     return false;
                 }
             }
